function [iSels,a,A, aic_y]=FRA_AIC(P,y)

% P: full regression matrix, y: output; n: number of terms to be selected
% iSels: index of terms selected; s: model coefficients; A: intermediate regression context; 
% the selection procedure will be terminated by the increase of AIC value
	[N,m]=size(P);
    %%%%%%%%%%%%[a11, a12,a13,......,a1m]
    %%%%%%%%%%A=[0,   a22,a23,......,a2m]
    %%%%%%%%%%%%[.......................]
    %%%%%%%%%%%%[0,     0,  0,......,anm]
	A=zeros(m,m);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%theat %%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%[a11]
    %%%%%%%%%%%%%%%%%%%%a=[a21]
    %%%%%%%%%%%%%%%%%%%%%%[...]
    %%%%%%%%%%%%%%%%%%%%%%[an1]
    k = 0;
	a=zeros(m,1);
    sse_reduce = [];
    sse_red_sum = 0;
    sse = y'*y;
    aic_1 = N*log(sse/N);
    aic_init = aic_1;
    aic = aic_1 - 0.000001; % used to pass the first while loop check
    aic_y = [];
    %%%%%%%%%%%%%%%%%%%%%%%%%i0rder=term-index%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	iOrder=1:m;
    %%%%%%%%%%Ay i.e. numerator of formula 31, Here give Ay initial value%%%%%%%%%%%%%%%%%%%%%%%
	Ay=y'*P;										% m*[N-1,N]
    %%%%%%%%%%Norm2 i.e. denominator of formula 31, Here give Norm2 initial value%%%%%%%%%%%%%%%%%%%%%%%
	Norm2=sum(P.*P);	% m*[N-1,N]
    stop_flag = 1;
	while stop_flag
        k = k+1;
        aic_1 = aic;
		reod=iOrder(k:m);
		Reduces=Ay(reod).*Ay(reod)./Norm2(reod);	% (m-k+1)*[0,2]
		[fMaxReduce,iMax]=max(Reduces);
%         if fMaxReduce/sse_red_sum < 5e-4
%             k=k-1;
%             break;
%         end
        sse_red_sum = sse_red_sum + fMaxReduce;
        sse_reduce = [sse_reduce,fMaxReduce];
        sse = sse - fMaxReduce;
        aic = N*log(sse/N)+2*k;
        aic_y = [aic_y,aic];  % record the AIC value for each model
        
		reod([1,iMax])=reod([iMax,1]);    %exchange index position
		cs=reod(1);
		reod=reod(2:end);                           %the left model terms
		s=P(:,cs)'*P(:,reod);						% (m-k)*[N-1,N]   %%%phi_k^T*phi_i not including the selected kth term
		for q=1:k-1
			s=s-A(q,cs)/A(q,iOrder(q))*A(q,reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,cs)=ajj
		end
		A(k,[cs,reod])=[Norm2(cs),s];               % resume orginal position
        
        %%%%%%%%%%%%%%up-compute kth A %%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%down-k+1%%%%%%%%%%%%%%%%%%%%%%%
		iOrder(k:m)=[cs,reod];                      % sort-seleted index remaining index
		if k<m
			s=Ay(cs)/A(k,cs)*A(k,reod);				% [0,m-k+1]
			Ay(reod)=Ay(reod)-s;					% [m-k,0]
			s=A(k,reod).*A(k,reod)/A(k,cs);			% [0,m-k+1]
			Norm2(reod)=Norm2(reod)-s;				% [m-k,0]
        end
        
         % determin the stop point  %%%%%
    if aic_1 < aic && abs((aic_1 - aic)/aic_init)  < 1e-3
        stop_flag = 0;
    end
    if aic_1 < aic && abs((aic - aic_1)/aic_init)  > 1e-3
        stop_flag = 0;
    end
    
    end
    n = k-1;
    A = A(1:n,:);
    a = a(1:n);
	for k=n:-1:1
		cs=iOrder(k);  % the final order
		reod=iOrder(k+1:n);
		a(k)=Ay(cs)-A(k,reod)*a(k+1:n);				% [n-k,n-k]
		a(k)=a(k)/A(k,cs);							% [0,1]
	end
	iSels=iOrder(1:n);
	A=[A(:,iOrder(1:n)),Ay(iOrder(1:n))'];
	return;
