function [theta,Jk_all] = ident_fra_loo_fix(p,y,term_select)
% FRA algorithm with leave one out method
%modified on 11/02/2010
%the order terms are fixed

% load code_test.mat
term_select = [192,9,143,176,11,140,14,16,167,201,54,48,42];
[N,m] = size(P);  % n is the number of data samples, m is the terms of possible combination
y = t;
A=zeros(m,m);
a = zeros(m,1);
k = 0;  % the initial order of selected terms
reod = 1:m;
reod(term_select) = [];
iOrder = [term_select, reod];
reod = [];
term_pool = 1:m;  % The initial candidate term pool
J_0 = mean(y.^2)+0.00001;  %make sure the initial value of J_k0 is large than J_k1, so the following cycle can start
J_1 = mean(y.^2);
n = length(term_select);
Ay=y'*P;	
Ad=sum(P.*P);
P_im = P;
d_im = ones(N,m) - P_im.^2./(ones(N,1)*Ad);
e_im = y*ones(1,m)- P_im.*(ones(N,1)*(Ay./Ad));

for k = 1:n
    reod = [];
    J_0 = J_1;
    cs = term_select(k);
    J_1 = sum((e_im(:,cs)./d_im(:,cs)).^2)/N;	% (m-k+1)*[0,2]
    reod = iOrder(k+1:m);    %exchange index position
	s=P(:,cs)'*P(:,reod);						% (m-k)*[N-1,N]   %%%phi_k^T*phi_i not including the selected kth term
	for q=1:k-1
		s=s-A(q,cs)/A(q,iOrder(q))*A(q,reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,cs)=ajj
	end
	A(k,[cs,reod])=[Ad(cs),s];               % resume orginal position
        
        %%%%%%%%%%%%%%up-compute kth A %%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%down-k+1%%%%%%%%%%%%%%%%%%%%%%%
        
		if k<n
			s=Ay(cs)/A(k,cs)*A(k,reod);				% [0,m-k+1]
			Ay(reod)=Ay(reod)-s;					% [m-k,0]
			s=A(k,reod).*A(k,reod)/A(k,cs);			% [0,m-k+1]
			Ad(reod)=Ad(reod)-s;				% [m-k,0]
            P_im(:,reod) = P_im(:,reod) - P_im(:,cs)*(A(k,reod)/A(k,cs));
            d_im(:,reod) = d_im(:,cs)*ones(1,m-k) - P_im(:,reod).^2./(ones(N,1)*Ad(reod));
            e_im(:,reod) = e_im(:,cs)*ones(1,m-k)- P_im(:,reod).*(ones(N,1)*(Ay(reod)./Ad(reod)));
        end
end       

    A = A(1:n,:);
    a = a(1:n);
    index = iOrder(1:n);
	for k=n:-1:1
		cs=iOrder(k);  % the final order
		reod=iOrder(k+1:n);
		a(k)=Ay(cs)-A(k,reod)*a(k+1:n);				% [n-k,n-k]
		a(k)=a(k)/A(k,cs);							% [0,1]
    end
    A = [A(1:n,iOrder(1:n)),Ay(iOrder(1:n))'];




















