function [iSels,a,A,lambda,Gamma]=ident_fra_loo_lr(P,y,update_n)

% modified by Jing Deng on 10th Jan 2011
% P: full regression matrix, y: output; n: number of terms to be selected
% iSels: index of terms selected; s: model coefficients; A: intermediate regression context;
% update_n: specifies how many cycles to update the regularisation
%parameters.
% clear all;
% close all;
% load bm1_0.05_noise_regression.mat
% y = t;
% update_n = 10;

	[N,m]=size(P);
    lambda = 0.001 * ones(1,m); % assign a small positive value for lambda
    cycle_count = 0; % used to count the regularisation updating
    index = 1:m;
    
while cycle_count < update_n;

	r_im = []; % the diagonal vector of residual matrix
    e_im = []; % modelling error vector
    reod = []; % used to store unselected terms
    A = zeros(m,m); % Auxiliary matrix
    a = zeros(m,1); % model coefficients vector
    k = 0;  % the initial order of selected terms
    iOrder=1:m;  %the initial terms that were selected
    term_pool = 1:m;  % The initial candidate term pool
%     J_0 = mean(y.^2)+0.00001;  %make sure the initial value of J_k0 is large than J_k1, so the following cycle can start
    J_1 = mean(y.^2); % initial LOO error
    stop_flag = 1; % used to terminate forward selection stage
    b = y'*P; % Auxiliary vector
    Ad=sum(P.*P); 
    P_im = P; % matrix with each column being \mathbf{p}^{(0)}
    %J_1 = N; 
    
    r_im = ones(N,m) - P_im.^2./(ones(N,1)*(Ad+lambda));
    e_im = y*ones(1,m)- P_im.*(ones(N,1)*(b./(Ad+lambda)));
    J_record = []; % used to record the loo error

	while stop_flag
		k = k+1;
        J_0 = J_1;
        reod = iOrder(k:m);
        J = sum((e_im(:,reod)./r_im(:,reod)).^2)/N;	% Calculate the loo error for each term
		[fMaxReduce,iMax] = min(J); % find out the one that gives minimum loo error
        J_record = [J_record,fMaxReduce]; % record the LOO error
		reod([1,iMax]) = reod([iMax,1]);    % exchange index position
        J_1 = fMaxReduce; % Assign new LOO error
		cs = reod(1); % The one that selected
		reod = reod(2:end);  % the model terms remaining in the candidate pool
		s = P(:,cs)'*P(:,reod);	 % vector; will be used to form the kth row of A; phi_k^T*phi_i not including the selected kth term
		
        for q = 1:k-1
			s = s - A(q,cs)/(A(q,iOrder(q)) + lambda(iOrder(q)))*A(q,reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,iOrder(q))=ajj
        end % used to calculate a_{k,j}
        
		A(k,[cs,reod])=[Ad(cs),s];  % update matrix A
        iOrder(k:m)=[cs,reod]; % sort-seleted index remaining index
        
        for q = 1:k-1
            C(k,iOrder(q)) = A(q,iOrder(k))/(A(q,iOrder(q)) + lambda(iOrder(q))); % update kth row of matrix C 
            for l = q+1:k-1
                C(k,iOrder(q)) = C(k,iOrder(q)) - A(l,iOrder(k))*C(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
            D(iOrder(q),k) = b(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q))))); % update kth column of matrix D
            for l = q+1:k-1
                D(iOrder(q),k) = D(iOrder(q),k) - b(iOrder(l))*C(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
        end
                          
        %%%%%%%%%%%%%%%% pre-caldulation for next selection %%%%%%%%%%%%%%%%%%%%%%%

		if k < m
			s = b(cs)/(A(k,cs)+lambda(cs))*A(k,reod);				% pre-calculate b_j^{(k+1)}
			b(reod) = b(reod)-s;					
			s = A(k,reod).*A(k,reod)/(A(k,cs)+lambda(cs));			% pre-calculate a_{j,j}^{(k+1)}
			Ad(reod) = Ad(reod)-s;				
            P_im(:,reod) = P_im(:,reod) - P_im(:,cs)*(A(k,reod)/(A(k,cs)+lambda(cs)));
            r_im(:,reod) = r_im(:,cs)*ones(1,m-k) - P_im(:,reod).^2./(ones(N,1)*(Ad(reod)+lambda(reod)));
            e_im(:,reod) = e_im(:,cs)*ones(1,m-k)- P_im(:,reod).*(ones(N,1)*(b(reod)./(Ad(reod)+lambda(reod))));
        end    
         %% determin the stop point  %%%%% J_0 < J_1
         if J_0 > J_1 && (J_0 - J_1)/mean(y.^2) < 2e-3
            stop_flag = 0;
         end
         if J_0 < J_1 && (J_1 - J_0)/mean(y.^2) > 2e-3
            stop_flag = 0;
         end
         if k == m
             stop_flag = 0;
         end
            
    end

    n = k;
% calculate the model parameters
    for q = 1:n
        D(iOrder(q),n+1) = b(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q)))));
        for l = q+1:n % Calculate the k+1th column of matrix D
            D(iOrder(q),n+1) = D(iOrder(q),n+1) - b(iOrder(l))*C(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
        end
    end
     a = D(iOrder(1:n),k+1);
     
% to calculate the diagonal elements of inverse M_k which is h_i
    z = 1/(A(1,iOrder(1)) + lambda(iOrder(1)));
    h = z;
    for q = 2:n
        z = 1/(A(q,iOrder(q)) + lambda(iOrder(q)));
        h = [h + z*C(q,iOrder(1:q-1)).^2,z];
    end
 % to update regularisation parameters
 gamma = ones(1,n) - lambda(iOrder(1:n)).*h;
%  Gamma2 = n - h*lambda(iOrder(1:n));
 Gamma = sum(gamma);
 
 error = y - P(:,iOrder(1:n))*a;
 sse_y = sse(error);
 
 lambda(iOrder(1:n)) =sum(e_im(:,iOrder(n)).^2)/(N-Gamma)*gamma./(a.^2)';
 
  for i = 1:n
     if lambda(iOrder(i)) > 1e15
         lambda(iOrder(i)) = 1e15;
     end
 end
 
 cycle_count = cycle_count + 1;
%  term_sel_record(cycle_count,:) = iOrder(1:n);
 index = index(iOrder(1:n));
 
 P = P(:,iOrder(1:n));
 [N,m]=size(P);
  lambda = lambda(iOrder(1:n));
  
end
    iSels = index;
	A=[A(:,iOrder(1:n)),b(iOrder(1:n))'];

	return;

    
    
    
    
    
    
    
    
    
    
    
    
    