function [index,a,A] = ident_fra_loo_new(P,t)
% FRA algorithm with leave one out method
%modified by Jing Deng on 12th January 2010
% load code_test.mat
[N,m] = size(P);  % n is the number of data samples, m is the terms of possible combination
y = t;
A=zeros(m,m);
a = zeros(m,1);
k = 0;  % the initial order of selected terms
iOrder=1:m;  %the initial terms that were selected
term_pool = 1:m;  % The initial candidate term pool
J_0 = mean(y.^2)+0.00001;  %make sure the initial value of J_k0 is large than J_k1, so the following cycle can start
J_1 = mean(y.^2);
stop_flag = 1;
k = 0;
Ay=y'*P;	
Ad=sum(P.*P);
P_im = P;
d_im = ones(N,m) - P_im.^2./(ones(N,1)*Ad);
e_im = y*ones(1,m)- P_im.*(ones(N,1)*(Ay./Ad));

while stop_flag
    k = k+1;
    J_0 = J_1;
    reod=iOrder(k:m);
    J = sum((e_im(:,reod)./d_im(:,reod)).^2)/N;	% (m-k+1)*[0,2]
	[fMaxReduce,iMax]=min(J);
    reod([1,iMax])=reod([iMax,1]);    %exchange index position
    J_1 = fMaxReduce;
	cs=reod(1);
	reod=reod(2:end);                           %the left model terms
	s=P(:,cs)'*P(:,reod);						% (m-k)*[N-1,N]   %%%phi_k^T*phi_i not including the selected kth term
	for q=1:k-1
		s=s-A(q,cs)/A(q,iOrder(q))*A(q,reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,cs)=ajj
	end
	A(k,[cs,reod])=[Ad(cs),s];               % resume orginal position
        
        %%%%%%%%%%%%%%up-compute kth A %%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%down-k+1%%%%%%%%%%%%%%%%%%%%%%%
		iOrder(k:m)=[cs,reod];                      % sort-seleted index remaining index
        
		if k<m
			s=Ay(cs)/A(k,cs)*A(k,reod);				% [0,m-k+1]
			Ay(reod)=Ay(reod)-s;					% [m-k,0]
			s=A(k,reod).*A(k,reod)/A(k,cs);			% [0,m-k+1]
			Ad(reod)=Ad(reod)-s;				% [m-k,0]
            P_im(:,reod) = P_im(:,reod) - P_im(:,cs)*(A(k,reod)/A(k,cs));
            d_im(:,reod) = d_im(:,cs)*ones(1,m-k) - P_im(:,reod).^2./(ones(N,1)*Ad(reod));
            e_im(:,reod) = e_im(:,cs)*ones(1,m-k)- P_im(:,reod).*(ones(N,1)*(Ay(reod)./Ad(reod)));
        end
        
         %%% determin the stop point  %%%%%
%     if J_0 > J_1 && (J_0 - J_1)/mean(y.^2) < 1e-3
%         stop_flag = 0;
%     end
%     if J_0 < J_1 && (J_1 - J_0)/mean(y.^2) > 1e-3
%         stop_flag = 0;
%     end
            if k == 25
                 stop_flag = 0;
            end
end       
        
    n = k;   
    A = A(1:n,:);
    a = a(1:n);
	for k=n:-1:1
		cs=iOrder(k);  % the final order
		reod=iOrder(k+1:n);
		a(k)=Ay(cs)-A(k,reod)*a(k+1:n);				% [n-k,n-k]
		a(k)=a(k)/A(k,cs);							% [0,1]
	end

index = iOrder(1:n);
A=[A(:,iOrder(1:n)),Ay(iOrder(1:n))'];




















