function [index,theta,a] = ident_ols_cross_validation(p,y,n_fold)
% OLS algorithm by using classic Gram-Schmidt method


[n,m] = size(p);  % n is the number of data samples, m is the terms of possible combination

n_test = floor(n/n_fold);

a = eye(m); % a should be an unit upper triangular matrix

comp = 0; % A temporary variable for chosing the a term which gives the maximal contribution to the finial model.

y_sse = []; % sum squared error

s = 1;  % the order of selected terms
ind_left = 1:m;    
for i=1:m
     for n_cross = 1:n_fold
         y_train = y;
         y_test = y(n_test*(n_cross-1)+1:n_test*n_cross);
         y_train(n_test*(n_cross-1)+1:n_test*n_cross) = [];
         phi_train = p;
         phi_test = p(n_test*(n_cross-1)+1:n_test*n_cross,:);
         phi_train(n_test*(n_cross-1)+1:n_test*n_cross,:) = [];
         
        w_1(:,i) = phi_train(:,i);
        g_1(i) = (w_1(:,i)'*y_train)/(w_1(:,i)'*w_1(:,i));
        mse_cross(n_cross) = mse(y_test - phi_test(:,i)*g_1(i)); %theta(1) = g(1)
     end
     err_1(i) = mean(mse_cross);
end

[err,index(s)] = min(err_1);
ind_left(index) = [];
y_sse(1) = err;
%%%%%%%%%%%% the second stage of OLS algorithm %%%%%%%%%%%%%%%%%%%
%  if the sum of error is big engough, the algorithm will stop, here the
%  stop criterion is 1-0.00012;

% y_sse([1,2]) = [1;1]; % just let y_sse(2) = y_sse(1)
    s = s+1;
    comp = 0;  % reset the compare variable
    err_1 = [ ]; % reset the variable which was used to store the temporary error
    
    for i = ind_left
       
       for n_cross = 1:n_fold
           y_train = y;
           y_test = y(n_test*(n_cross-1)+1:n_test*n_cross);
           y_train(n_test*(n_cross-1)+1:n_test*n_cross) = [];
           phi_train = p;
           phi_test = p(n_test*(n_cross-1)+1:n_test*n_cross,:);
           phi_train(n_test*(n_cross-1)+1:n_test*n_cross,:) = [];
         
           w_a = 0; % temporary variable
           
           w(:,1) = phi_train(:,index(1));
           a_1 = (w(:,1)'*phi_train(:,i))/(w(:,1)'*w(:,1));
           w_a = a_1*w(:,1);
           g(1) = (w(:,1)'*y_train)/(w(:,1)'*w(:,1));
           a(1,s) = a_1;
          
           w_1(:,i) = phi_train(:,i) - w_a;
           g_1(i) = (w_1(:,i)'*y_train)/(w_1(:,i)'*w_1(:,i));
           a_f = a(1:s, 1:s);
           theta = inv(a_f)*[g(1),g_1(i)]';
           mse_cross(n_cross) = mse(y_test - phi_test(:,[index,i])*theta);
       end
        err_1(i) = mean(mse_cross);
                     
    end
    err_1(index(1)) = [];
    index_temp = 0;
    [err,index_temp] = min(err_1);
    index(s) = ind_left(index_temp);
    y_sse(s) = err;

     
while (y_sse(s) <= y_sse(s-1))
    s = s+1;
    comp = 0;  % reset the compare variable
    err_1 = [ ]; % reset the variable which was used to store the temporary error
    
    for i = ind_left
       
       for n_cross = 1:n_fold
           y_train = y;
           y_test = y(n_test*(n_cross-1)+1:n_test*n_cross);
           y_train(n_test*(n_cross-1)+1:n_test*n_cross) = [];
           phi_train = p;
           phi_test = p(n_test*(n_cross-1)+1:n_test*n_cross,:);
           phi_train(n_test*(n_cross-1)+1:n_test*n_cross,:) = [];
         
           w_a = 0; % temporary variable
           
           w(:,1) = phi_train(:,index(1));
           for t_i = 2:s-1   %column
               
               for t_j = 1:t_i-1  %row
                   a(t_j,t_i) = (w(:,t_i-1)'*phi_train(:,index(t_i)))/(w(:,t_i-1)'*w(:,t_i-1));
                   w_a = a(t_j,t_i)*w(:,t_i-1)+w_a;
               end
               w(:,t_i) = phi_train(:,t_i) - w_a;
               g(t_i) = (w(:,t_i)'*y_train)/(w(:,t_i)'*w(:,t_i));
           end
           
           w_a = 0; % temporary variable
           
           for j = 1:s-1
               a_1(j) = (w(:,j)'*phi_train(:,i))/(w(:,j)'*w(:,j));
               w_a = a_1(j)*w(:,j)+w_a;
               a(j,s) = a_1(j);
           end
           w_1(:,i) = phi_train(:,i) - w_a;
           g_1(i) = (w_1(:,i)'*y_train)/(w_1(:,i)'*w_1(:,i));
           a_f = a(1:s, 1:s);
           theta = inv(a_f)*[g(1:s-1),g_1(i)]';
           mse_cross(n_cross) = mse(y_test - phi_test(:,[index,i])*theta);
       end
        err_1(i) = mean(mse_cross);
                     
    end
    err_1(index(1:s-1)) = [];
    index_temp = 0;
    [err,index_temp] = min(err_1);
    index(s) = ind_left(index_temp);
    y_sse(s) = err;
     
end



