function [ReOrder,theta,lambda, Gamma] = ident_ols_reg2(p,y,update_n)
% locally regularized OLS algorithm by using classic Gram-Schmidt method
%by Jing, date 25/01/2010

% clear all;
% close all;
% load code_test.mat
% p = P;
% y = t;
% update_n = 10;
[N,m] = size(p);  % n is the number of data samples, m is the terms of possible combination

lambda = 0.001 * ones(1,m);
cycle_count = 1;
ts = y'*y; %for further use
t = y;
aic_1 =0;
aic =  N*log(ts/N);
aic_init = aic;
ReOrder = 1:m;
while cycle_count < update_n

aic_y = [];    
iOrder = 1:m;
w = p;  
a = zeros(m,m); % a is an unit upper triangular matrix

%%%%%%%%%% the first stage of OLS algorithm %%%%%%%%%%%%%%%%
% select the one column from regressive matrix P for orthogonal matrix W
reod = iOrder;
k = 0;
wd = zeros(1,m);
rerr = zeros(1,m);
g = zeros(1,m);
err_sum = 0;
y = t;
stop_flag = 1;
while stop_flag
%     stop_flag = 0;
    k = k+1;
    aic_1 = aic;
    
    wd(reod) = sum(w(:,reod).*w(:,reod)); %step 1, calculate phi'*phi
    g(reod) = y'*w(:,reod)./(wd(reod) + lambda(reod));
    rerr(reod) = g(reod).^2.*(wd(reod) + lambda(reod))/ts;
    [fMaxReduce,iMax]=max(rerr(reod));
    reod([1,iMax])=reod([iMax,1]); 
    cs=reod(1);
    reod=reod(2:end); 
    iOrder(k:m)=[cs,reod];   
    
    a(k,cs) = 1;
    a(1:k,reod) = w(:,iOrder(1:k))'*p(:,reod)./(wd(iOrder(1:k))'*ones(1,m-k));
    w(:,reod) = p(:,reod) - w(:,iOrder(1:k))*a(1:k,reod);
    
    err_sum = sum(rerr(iOrder(1:k)));
    sse = (1-err_sum) * ts;
    aic = N*log(sse/N)+2*k;
    aic_y = [aic_y,aic];
    
%     if cycle_count == 1
%         if k < 25
%             stop_flag = 1;
%         end
%     end
%     if cycle_count > 1
%         if k < m
%             stop_flag = 1;
%         end
%     end
    
        % determin the stop point  %%%%%
    if cycle_count == 1
%         if aic_1 > aic && abs((aic_1 - aic)/aic_init)  < 5e-3
%             stop_flag = 0;
%         end
%         if aic_1 < aic && abs((aic - aic_1)/aic_init)  > 5e-5
%             stop_flag = 0;
%         end
          if k == 30;
              stop_flag = 0;
          end
%         if err_sum > 0.85
%             stop_flag = 0;
%         end
    end
    if cycle_count > 1
        if k == m
            stop_flag = 0;
        end
    end
end

a_f = a(1:k,iOrder(1:k)); % the final a only consist the first s rows and columns
theta = (a_f)\g(iOrder(1:k))'; % used to display the estimated parameters corresponding to each selected term

cycle_count = cycle_count+1;
%%% updating the regularisation parameters

 %calculate the associate value of each 
 %selected term, if this value is near 1, this term is important, if it is
 %near 0, then this term is insignificant.
gamma = wd(iOrder(1:k))./(lambda(iOrder(1:k))+wd(iOrder(1:k)));

Gamma = sum(gamma); %the effective number of terms
Gamma_dj(cycle_count)=Gamma;

% update the regularisation parameters for each selected terms
lambda(iOrder(1:k)) = sse/(N - Gamma) * gamma./(g(iOrder(1:k)).^2);

ReOrder = ReOrder(iOrder(1:k));
p = p(:,iOrder(1:k));
m = k;
lambda = lambda(iOrder(1:k));


end

















