function [u_sel,a]=ident_tss_elm_rbf(u,y,n,flag)
% two-stage selection with extreme learning machine
% version 0.1
% date: 12 Jan 2011
% by Jing Deng
% u is the input data matrix
% y is the output vector
% n is the final network size
% flag = 0, use FRA; flag = 1, use two-stage selection

%     load bm1_0.05_noise.mat;
%     u = P(1:200);
%     y = Y(1:200);
%     flag = 1;
%     n = 8;

[N,m] = size(u); % retain the input demension and data sample size
sigma_range = [0.1, 4]; % specify the range to random choosen RBF centre width


ind_centre = randi(N,1,N); % generate N centres randomly from the data samples
rbf_width = sigma_range(1) + (sigma_range(2) - sigma_range(1)) * rand(m,N); % m by N;  generate N width vectors for each center

% to form the regression matrix
P = []; % start with an empty regression matrix
u_mu = u(ind_centre,:); % the mean matrix used by Gaussian mixture distribution
u_sigma(1,:,:) = rbf_width; % the variance matrix used by Gaussian mixture distribution
obj = gmdistribution(u_mu,u_sigma); % u_mu is N*m and u_sigma is m * N; used to compute Mahalanobis distance
d_mahal = mahal(obj,u); % compute the Mahalanobis distance
Phi = exp(-0.5 * sqrt(d_mahal)); % produce the regression matrix

%%%%%%%%%%% use a subset selection algorithm %%%%%%%%%%%%%%%
% [iSels, a, A] = mssAlgorithm2(Phi,y,n);
% [a, iSels] = mssTwoStage1(Phi, y, n, flag);
[iSels,a,J_record,term_record,sse_record] = ident_two_stage_loo_new(Phi,y);
%%%%%%%%%%%% retain the selected centres and widths %%%%%%%%%
u_sel = [u_mu(iSels,:)'; rbf_width(:,iSels)];
