function [iSels,a,A,lambda,Gamma]=ident_tss_loo_lr(P,y,update_n)

% modified by Jing Deng on 10th Jan 2011
% P: full regression matrix, y: output; n: number of terms to be selected
% iSels: index of terms selected; s: model coefficients; A: intermediate regression context;
% update_n: specifies how many cycles to update the regularisation
%parameters.
% clear all;
% close all;
% load bm1_0.05_noise_regression.mat
% y = t;
% update_n = 10;

	[N,m]=size(P);
    lambda = 0.001 * ones(1,m); % assign a small positive value for lambda
    cycle_count = 0; % used to count the regularisation updating
    index = 1:m;
    
while cycle_count < update_n;

	r_im = []; % the diagonal vector of residual matrix
    e_im = []; % modelling error vector
    reod = []; % used to store unselected terms
    A = zeros(m,m); % Auxiliary matrix
    a = zeros(m,1); % model coefficients vector
    C = zeros(m,m);
    D = zeros(m,m);
    k = 0;  % the initial order of selected terms
    iOrder=1:m;  %the initial terms that were selected
    term_pool = 1:m;  % The initial candidate term pool
%     J_0 = mean(y.^2)+0.00001;  %make sure the initial value of J_k0 is large than J_k1, so the following cycle can start
    J_1 = mean(y.^2); % initial LOO error
    stop_flag = 1; % used to terminate forward selection stage
    b = y'*P; % Auxiliary vector
    Ad=sum(P.*P); 
    P_im = P; % matrix with each column being \mathbf{p}^{(0)}
    %J_1 = N; 
    
    r_im = ones(N,m) - P_im.^2./(ones(N,1)*(Ad+lambda));
    e_im = y*ones(1,m)- P_im.*(ones(N,1)*(b./(Ad+lambda)));
    J_record = []; % used to record the loo error
%% First stage - select terms based on loo
	while stop_flag
		k = k+1;
        J_0 = J_1;
        reod = iOrder(k:m);
        J = sum((e_im(:,reod)./r_im(:,reod)).^2)/N;	% Calculate the loo error for each term
		[fMaxReduce,iMax] = min(J); % find out the one that gives minimum loo error
        J_record = [J_record,fMaxReduce]; % record the LOO error
		reod([1,iMax]) = reod([iMax,1]);    % exchange index position
        J_1 = fMaxReduce; % Assign new LOO error
		cs = reod(1); % The one that selected
		reod = reod(2:end);  % the model terms remaining in the candidate pool
		s = P(:,cs)'*P(:,reod);	 % vector; will be used to form the kth row of A; phi_k^T*phi_i not including the selected kth term
		
        for q = 1:k-1
			s = s - A(q,cs)/(A(q,iOrder(q)) + lambda(iOrder(q)))*A(q,reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,iOrder(q))=ajj
        end % used to calculate a_{k,j}
        
		A(k,[cs,reod])=[Ad(cs),s];  % update matrix A
        iOrder(k:m)=[cs,reod]; % sort-seleted index remaining index
        
        for q = 1:k-1
            C(k,iOrder(q)) = A(q,iOrder(k))/(A(q,iOrder(q)) + lambda(iOrder(q))); % update kth row of matrix C 
            for l = q+1:k-1
                C(k,iOrder(q)) = C(k,iOrder(q)) - A(l,iOrder(k))*C(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
            D(iOrder(q),k) = b(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q))))); % update kth column of matrix D
            for l = q+1:k-1
                D(iOrder(q),k) = D(iOrder(q),k) - b(iOrder(l))*C(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
        end
                          
        %%%%%%%%%%%%%%%% pre-caldulation for next selection %%%%%%%%%%%%%%%%%%%%%%%

		if k < m
			s = b(cs)/(A(k,cs)+lambda(cs))*A(k,reod);				% pre-calculate b_j^{(k+1)}
			b(reod) = b(reod)-s;					
			s = A(k,reod).*A(k,reod)/(A(k,cs)+lambda(cs));			% pre-calculate a_{j,j}^{(k+1)}
			Ad(reod) = Ad(reod)-s;				
            P_im(:,reod) = P_im(:,reod) - P_im(:,cs)*(A(k,reod)/(A(k,cs)+lambda(cs)));
            r_im(:,reod) = r_im(:,cs)*ones(1,m-k) - P_im(:,reod).^2./(ones(N,1)*(Ad(reod)+lambda(reod)));
            e_im(:,reod) = e_im(:,cs)*ones(1,m-k)- P_im(:,reod).*(ones(N,1)*(b(reod)./(Ad(reod)+lambda(reod))));
        end    
         %% determin the stop point  %%%%% J_0 < J_1
         if J_0 > J_1 && (J_0 - J_1)/mean(y.^2) < 1e-5 && k>1
            stop_flag = 0;
         end
         if J_0 < J_1 && (J_1 - J_0)/mean(y.^2) > 1e-5 && k>1
            stop_flag = 0;
         end
         if k == m
             stop_flag = 0;
         end
            
    end
    
    n = k;
    rn = r_im(:,iOrder(n));
    en = e_im(:,iOrder(n));
    
%% the second stage
%if cycle_count == 0
loop_count = 0;  % record how many review loops have been executed in this stage
cycle_flag = 1;
J_record = J_0;
term_record = [];
sse_record  = [];
sse_record = [sse_record,sqrt(sum(en.^2)/N)];
term_record = [term_record;iOrder(1:n)];  % record the changes of selected terms
while cycle_flag
    cycle_flag = 0;
    loop_count = loop_count+1;
    
     for k = n-1:-1:1         % move k-th term to the last order
            reod = iOrder(n+1:end);
            for q = k:n-1  %continues shift two adjacent terms
                A_q = zeros(1,m); %to store the new q-th row of matrix A
                A_q1 = A_q; %to store the new q+1-th row of matrix A
                C_q = A_q; %to store the new q-th row of matrix C
                C_q1 = A_q; %to store the new q+1-th row of matrix C
                D_q = zeros(m,1);
                D_q1 = D_q;
                
                A_q(iOrder(q+1)) = A(q+1,iOrder(q+1)) + A(q,iOrder(q+1))^2/(A(q,iOrder(q)) + lambda(iOrder(q)));     % new a_{q,q}           
                A_q(iOrder(q)) = A(q,iOrder(q+1));     %update new a_{q,q+1}
                A_q(iOrder(q+2:m)) = A(q+1,iOrder(q+2:m)) + A(q, iOrder(q+1))/(A(q,iOrder(q)) + lambda(iOrder(q)))*A(q,iOrder(q+2:m));     % new a_{q,j} j from q+1 to m             
                A_q1(iOrder(q)) = A(q,iOrder(q)) - A(q,iOrder(q+1))^2/(A_q(iOrder(q+1)) + lambda(iOrder(q+1)));     % new a_{q+1,q+1}
                A_q1(iOrder(q+2:m)) = A(q, iOrder(q+2:m)) - A(q, iOrder(q+1))/(A_q(iOrder(q+1)) + lambda(iOrder(q+1))) * A_q(iOrder(q+2:m));     % new a_{q+1,j} j from q+1 to m
                
                C_q(iOrder(1:q-1)) = C(q+1,iOrder(1:q-1)) + A(q, iOrder(q+1))/(A(q,iOrder(q)) + lambda(iOrder(q))) * C(q, iOrder(1:q-1));     %new c_{q,j} j from 1 to q-1
                C_q1(iOrder(q+1)) = A(q, iOrder(q+1))/(A_q(iOrder(q+1)) + lambda(iOrder(q+1)));     %new c_{q+1,q}
                C_q1(iOrder(1:q-1)) = C(q, iOrder(1:q-1)) - A(q, iOrder(q+1))/(A_q(iOrder(q+1)) + lambda(iOrder(q+1))) * C_q(iOrder(1:q-1));     %new c_{q+1,j} j from 1 to q-1
                
                b_q = b(iOrder(q+1)) + A(q, iOrder(q+1)) * b(iOrder(q))/((A(q,iOrder(q)) + lambda(iOrder(q))));     %new b_q
                b_q1 = b(iOrder(q)) - A(q, iOrder(q+1)) * b_q / (A_q(iOrder(q+1)) + lambda(iOrder(q+1)));     %new b_{q+1}
                
                D_q(iOrder(1:q-1)) = D(iOrder(1:q-1),q+1) + b(iOrder(q))/((A(q,iOrder(q)) + lambda(iOrder(q)))) * C(q,iOrder(1:q-1))';     % new d_{i,q} i from 1 to q-1
                D_q1(iOrder(q+1)) = b_q/(A_q(iOrder(q+1)) + lambda(iOrder(q+1)));     %new d_{q,q+1}
                D_q1(iOrder(1:q-1)) = D(iOrder(1:q-1), q) - b_q/(A_q(iOrder(q+1)) + lambda(iOrder(q+1))) * C_q(iOrder(1:q-1))';     %new d_{i,q+1} i from 1 to q-1
                
                P_q = P_im(:,iOrder(q+1)) + A(q, iOrder(q+1))/(A(q,iOrder(q)) + lambda(iOrder(q)))*P_im(:,iOrder(q)); %new P_q^{(q-1)}
                P_q1 = P_im(:,iOrder(q)) - A(q, iOrder(q+1))/(A_q(iOrder(q+1)) + lambda(iOrder(q+1)))*P_q; %new P_{q+1}^{(q)}
                              
                A([q,q+1],:) = [A_q;A_q1];
                C([q,q+1],:) = [C_q; C_q1];
                b(iOrder([q+1,q])) = [b_q,b_q1];
                D(:,[q,q+1]) = [D_q,D_q1];
                P_im(:,iOrder([q+1,q])) = [P_q,P_q1];
                
                iOrder([q,q+1]) = iOrder([q+1,q]); %shift two adjacent terms  
                Ad(iOrder(1:n)) = diag(A(1:n,iOrder(1:n)));
            end
            Ad_n = Ad;
            b_n = b;
            P_n = P_im;

            Ad_n(reod) = Ad(reod) + A(n,reod).^2/(Ad(iOrder(n)) + lambda(iOrder(n)));
            b_n(reod) = b(reod) + b(iOrder(n))/(Ad(iOrder(n)) + lambda(iOrder(n)))*A(n,reod);
            
            P_n(:,reod) = P_im(:,reod) + P_im(:,iOrder(n))*(A(n,reod)/(A(n,iOrder(n))) + lambda(iOrder(n)));
            r_n(:,reod) = rn*ones(1,m-n) + P_im(:,iOrder(n)).^2/(A(n,iOrder(n)) + lambda(iOrder(n)))*ones(1,m-n) - P_n(:,reod).^2./(ones(N,1)*(Ad_n(reod) + lambda(iOrder(n))));
            e_n(:,reod) = en*ones(1,m-n) + b(iOrder(n))/(A(n,iOrder(n)) + lambda(iOrder(n)))*P_im(:,iOrder(n))*ones(1,m-n)- P_n(:,reod).*(ones(N,1)*(b_n(reod)./(Ad_n(reod)) + lambda(iOrder(n))));
            
            J_pool = sum((e_n(:,reod)./r_n(:,reod)).^2)/N;	% (m-k+1)*[0,2]
            [fMaxReduce,iMax]=min(J_pool);
            
        if J_0 > fMaxReduce
                J_0 = fMaxReduce;
                cycle_flag = 1;
                J_record = [J_record,fMaxReduce];
                
                cs = reod(iMax); % candidate selected
                A_n = zeros(1,m); % to store the new n-th row of matrix A
                C_n = A_n;
                D_n = zeros(m,1);
                reod(iMax) = [];
                
                en = e_n(:,cs);
                rn = r_n(:,cs);
                
                sse_record = [sse_record,sqrt(sum(en.^2)/N)];
                A_n(cs) = Ad_n(cs);     %new a_{n,n}
                A_n(iOrder(n)) = A(n, cs);     %new a_{n,cs}
                A_n(reod) = P(:,cs)'*P(:,reod);     %new a_{n,j} for j = n+1:m, j!=n+iMax;
                for q = 1:n-1
                    A_n(reod) = A_n(reod) - A(q,cs)/(A(q,iOrder(q))+ lambda(iOrder(q)))*A(q,reod);
                end               
                Ad(iOrder(n)) = Ad(iOrder(n)) - A_n(iOrder(n))^2/(A_n(cs)+ lambda(cs));     %new a_{cs,cs}
                Ad(reod) = Ad_n(reod) - A_n(reod).^2/(A_n(cs)+ lambda(cs));     %new a_{j,j} for j = n+1:m, j!=n+iMax;
      
                for q = 1:n-1
                    C_n(iOrder(q)) = A(q,cs)./(A(q, iOrder(q)) + lambda(iOrder(q)));
                	for l = q+1:n-1
                        C_n(iOrder(q)) = C_n(iOrder(q)) - A(l,cs)*C(l,iOrder(q))/(A(l, iOrder(l)) + lambda(iOrder(l)));
                    end
                end
                
                b(cs) = b_n(cs);
                b(iOrder(n)) = b(iOrder(n)) - A_n(iOrder(n)) * b(cs) / (A_n(cs) + lambda(cs));     %new b_cs
                b(reod) = b_n(reod) - b(cs)/(A_n(cs)+ lambda(cs)) * A_n(reod);     %new b_j for j = n+1:m, j!=n+iMax;
                
                D_n(cs) = b(cs)/(A_n(cs) + lambda(cs));     %new C_{n,n+1}
                D_n(iOrder(1:n-1)) = D(iOrder(1:n-1), n) - C_n(iOrder(1:n-1))'*b(cs)/(A_n(cs) + lambda(cs));     %new C_{i,n+1} for i = 1 to n-1
                
                P_im(:,iOrder(n)) =  P_im(:,iOrder(n)) - A_n(iOrder(n))/(A_n(cs) + lambda(cs))*P_n(:,cs);
                P_im(:,reod) =  P_n(:,reod) - P_n(:,cs)*A_n(reod)/(A_n(cs) + lambda(cs));
                P_im(:,cs) = P_n(:,cs);

                A(n,:) = A_n;
       
                iOrder([n,n+iMax]) = iOrder([n+iMax,n]); %shift two adjacent terms  
                Ad(iOrder(1:n)) = diag(A(1:n,iOrder(1:n)));
                term_record = [term_record;iOrder(1:n)];
            end
     end
end
%end

% calculate the model parameters
    for q = 1:n
        D(iOrder(q),n+1) = b(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q)))));
        for l = q+1:n % Calculate the k+1th column of matrix D
            D(iOrder(q),n+1) = D(iOrder(q),n+1) - b(iOrder(l))*C(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
        end
    end
     a = D(iOrder(1:n),n+1);
     
% to calculate the diagonal elements of inverse M_k which is h_i
    z = 1/(A(1,iOrder(1)) + lambda(iOrder(1)));
    h = z;
    for q = 2:n
        z = 1/(A(q,iOrder(q)) + lambda(iOrder(q)));
        h = [h + z*C(q,iOrder(1:q-1)).^2,z];
    end
 % to update regularisation parameters
 gamma = ones(1,n) - lambda(iOrder(1:n)).*h;
%  Gamma2 = n - h*lambda(iOrder(1:n));
 Gamma = sum(gamma);
 
 error = y - P(:,iOrder(1:n))*a;
 sse_y = sse(error);
 
 lambda(iOrder(1:n)) =sum(en.^2)/(N-Gamma)*gamma./(a.^2)';
 
  for i = 1:n
     if lambda(iOrder(i)) > 1e15
         lambda(iOrder(i)) = 1e15;
     end
 end
 
 cycle_count = cycle_count + 1;
%  term_sel_record(cycle_count,:) = iOrder(1:n);
 index = index(iOrder(1:n));
 
 P = P(:,iOrder(1:n));
 [N,m]=size(P);
  lambda = lambda(iOrder(1:n));
  
end
    iSels = index;
	A=[A(1:n,iOrder(1:n)),b(iOrder(1:n))'];

	return;

    
    
    
    
    
    
    
    
    
    
    
    
    