function [iSels,theta, sse_y,SSERec,lambda,Gamma]=ident_two_stage_reg_new(P,t,n,update_n)
%input: P: candidate regression matrices,  y: output vector; n: desdired number of selections; 
% opt: 0-forward only, 1-forward+backward; 
% Output: a: regression coefficients (output weights), iSels: index of selected regressor;
% SSE: error of the model; Context: regression context; SSERec: records of SSEs for the selections; 
%update_n specifies how many cycles to update the regularisation
%parameters.

% update_n = 10;
% load code_test.mat;    n = 15;
    [N,m]=size(P);

    ReOrder = 1:m;
    lambda_init = 0.001*ones(1,m);
    [theta,A,iSels,Ad,iOrder, sse_reduction, sse_y,Ay,B,C,lambda] = first_stage_selection(P,t,n,ReOrder,lambda_init);
 
     d = 1/(A(1,iOrder(1)) + lambda(iOrder(1)));
        h = d;
        for q = 2:n
            d = 1/(A(q,iOrder(q)) + lambda(iOrder(q)));
            h = [h + d*B(q,iOrder(1:q-1)).^2,d];
        end
         gamma = ones(1,n) - lambda(iOrder(1:n)).*h;
    Gamma = sum(gamma);
    lambda(iOrder(1:n)) = sse_y/(N-Gamma)*gamma./(theta.^2)';
    reod = 1:m;
    reod(iOrder(1:n)) = [];
    lambda(reod) = 10*ones(1,m-n);
        
    % for lambda, it's elements index should use iOrder()
    % for matrix A, it's column index should use iOrder()
    % for matrix B, it's column index should use iOrder()
    % for vector Ay, it's elements index should use iOrder()
    % for matrix C, it's row index should use iOrder()
    reod = iOrder(n+1:end);
	SSERec=sse_y;
    review_flag = 1;
    cycle_count = 1;
	while review_flag
        cycle_count = cycle_count + 1;
        review_flag = 0;
        for k = n-1:-1:1         %move k-th term to the last order
            reod = iOrder(n+1:end);
            for q = k:n-1  %continues shift two adjacent terms
                A_q = zeros(1,m); %to store the new q-th row of matrix A
                A_q1 = A_q; %to store the new q+1-th row of matrix A
                B_q = A_q; %to store the new q-th row of matrix B
                B_q1 = A_q; %to store the new q+1-th row of matrix B
                C_q = zeros(m,1);
                C_q1 = C_q;
                
                A_q(iOrder(q+1)) = A(q+1,iOrder(q+1)) + A(q,iOrder(q+1))^2/(A(q,iOrder(q)) + lambda(iOrder(q)));     % new a_{q,q}           
                A_q(iOrder(q)) = A(q,iOrder(q+1));     %update new a_{q,q+1}
                A_q(iOrder(q+2:m)) = A(q+1,iOrder(q+2:m)) + A(q, iOrder(q+1))/(A(q,iOrder(q)) + lambda(iOrder(q)))*A(q,iOrder(q+2:m));     % new a_{q,j} j from q+1 to m             
                A_q1(iOrder(q)) = A(q,iOrder(q)) - A(q,iOrder(q+1))^2/(A_q(iOrder(q+1)) + lambda(iOrder(q+1)));     % new a_{q+1,q+1}
                A_q1(iOrder(q+2:m)) = A(q, iOrder(q+2:m)) - A(q, iOrder(q+1))/(A_q(iOrder(q+1)) + lambda(iOrder(q+1))) * A_q(iOrder(q+2:m));     % new a_{q+1,j} j from q+1 to m
                
                B_q(iOrder(1:q-1)) = B(q+1,iOrder(1:q-1)) + A(q, iOrder(q+1))/(A(q,iOrder(q)) + lambda(iOrder(q))) * B(q, iOrder(1:q-1));     %new b_{q,j} j from 1 to q-1
                B_q1(iOrder(q+1)) = A(q, iOrder(q+1))/(A_q(iOrder(q+1)) + lambda(iOrder(q+1)));     %new b_{q+1,q}
                B_q1(iOrder(1:q-1)) = B(q, iOrder(1:q-1)) - A(q, iOrder(q+1))/(A_q(iOrder(q+1)) + lambda(iOrder(q+1))) * B_q(iOrder(1:q-1));     %new b_{q+1,j} j from 1 to q-1
                
                Ay_q = Ay(iOrder(q+1)) + A(q, iOrder(q+1)) * Ay(iOrder(q))/((A(q,iOrder(q)) + lambda(iOrder(q))));     %new ay_q
                Ay_q1 = Ay(iOrder(q)) - A(q, iOrder(q+1)) * Ay_q / (A_q(iOrder(q+1)) + lambda(iOrder(q+1)));     %new ay_{q+1}
                
                %C(iOrder([q, q+1]), q+1:n+1) = C(iOrder([q+1,q]),q+1:n+1);
                C_q(iOrder(1:q-1)) = C(iOrder(1:q-1),q+1) + Ay(iOrder(q))/((A(q,iOrder(q)) + lambda(iOrder(q)))) * B(q,iOrder(1:q-1))';     % new c_{i,q} i from 1 to q-1
                C_q1(iOrder(q+1)) = Ay_q/(A_q(iOrder(q+1)) + lambda(iOrder(q+1)));     %new c_{q,q+1}
                C_q1(iOrder(1:q-1)) = C(iOrder(1:q-1), q) - Ay_q/(A_q(iOrder(q+1)) + lambda(iOrder(q+1))) * B_q(iOrder(1:q-1))';     %new c_{i,q+1} i from 1 to q-1
                
                A([q,q+1],:) = [A_q;A_q1];
                B([q,q+1],:) = [B_q;B_q1];
                Ay(iOrder([q+1,q])) = [Ay_q,Ay_q1];
                C(:,[q,q+1]) = [C_q, C_q1];
                
                iOrder([q,q+1]) = iOrder([q+1,q]); %shift two adjacent terms  
                Ad(iOrder(1:n)) = diag(A(1:n,iOrder(1:n)));
            end
            Ad_n = Ad;
            Ay_n = Ay;
            Ad_n(reod) = Ad(reod) + A(n,reod).^2/(Ad(iOrder(n)) + lambda(iOrder(n)));
            Ay_n(reod) = Ay(reod) + Ay(iOrder(n))/(Ad(iOrder(n)) + lambda(iOrder(n)))*A(n,reod);
            
            Reduces_sel = Ay(iOrder(n))^2/(Ad(iOrder(n)) + lambda(iOrder(n)));
            Reduces_pool = Ay_n(reod).^2./(Ad_n(reod) + lambda(reod));
            [fMaxReduce,iMax]=max(Reduces_pool);
            
            if Reduces_sel < fMaxReduce
                review_flag = 1;
                sse_y = sse_y + Reduces_sel - fMaxReduce;
                SSERec = [SSERec;sse_y];
                cs = reod(iMax); % candidate selected
                A_n = zeros(1,m); %to store the new q-th row of matrix A
                B_n = A_n; %to store the new q-th row of matrix B
                C_n = zeros(m,1);
                reod(iMax) = [];
                
                A_n(cs) = Ad_n(cs);     %new a_{n,n}
                A_n(iOrder(n)) = A(n, cs);     %new a_{n,cs}
                A_n(reod) = P(:,cs)'*P(:,reod);     %new a_{n,j} for j = n+1:m, j!=n+iMax;
                for q = 1:n-1
                    A_n(reod) = A_n(reod) - A(q,cs)/(A(q,iOrder(q))+lambda(iOrder(q)))*A(q,reod);
                end               
                Ad(iOrder(n)) = Ad(iOrder(n)) - A_n(iOrder(n))^2/(A_n(cs) + lambda(cs));     %new a_{cs,cs}
                Ad(reod) = Ad_n(reod) - A_n(reod).^2/(A_n(cs) + lambda(cs));     %new a_{j,j} for j = n+1:m, j!=n+iMax;
                
                for q = 1:n-1
                    B_n(iOrder(q)) = A(q,cs)./(A(q, iOrder(q)) + lambda(iOrder(q)));
                	for l = q+1:n-1
                        B_n(iOrder(q)) = B_n(iOrder(q)) - A(l,cs)*B(l,iOrder(q))/(A(l, iOrder(l)) + lambda(iOrder(l)));
                    end
                end
                
                Ay(cs) = Ay_n(cs);
                Ay(iOrder(n)) = Ay(iOrder(n)) - A_n(iOrder(n)) * Ay(cs) / (A_n(cs) + lambda(cs));     %new ay_cs
                Ay(reod) = Ay_n(reod) - Ay(cs) / (A_n(cs) + lambda(cs)) * A_n(reod);     %new ay_j for j = n+1:m, j!=n+iMax;
                
                C_n(cs) = Ay(cs)/(A_n(cs) + lambda(cs));     %new C_{n,n+1}
                C_n(iOrder(1:n-1)) = C(iOrder(1:n-1), n) - B_n(iOrder(1:n-1))'*Ay(cs)/(A_n(cs) + lambda(cs));     %new C_{i,n+1} for i = 1 to n-1
                
                A(n,:) = A_n;
                B(n,:) = B_n;
                C(:,n+1) = C_n;
                
                iOrder([n,n+iMax]) = iOrder([n+iMax,n]); %shift two adjacent terms  
                Ad(iOrder(1:n)) = diag(A(1:n,iOrder(1:n)));
            end
        end
    end
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%%%%%%%%%%%%  to update the regularisation parameters   %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    P = P(:,iOrder(1:n));
    lambda = lambda(iOrder(1:n));
%     n = 15;
    ReOrder = iOrder(1:n);
    for i = 1:update_n
        
        [theta,A,iSels, Ad, iOrder,  sse_reduction, sse_y,Ay,B,C,lambda]=first_stage_selection(P,t,n,ReOrder,lambda);
        
        %calculate the model parameters
        for q=1:n
            C(iOrder(q),n+1) = Ay(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q)))));
            for l = q+1:n
                C(iOrder(q),n+1) = C(iOrder(q),n+1) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
        end
        a = C(iOrder(1:n),n+1);
     
% to calculate the diagonal elements of inverse M_k which is h_i
        d = 1/(A(1,iOrder(1)) + lambda(iOrder(1)));
        h = d;
        for q = 2:n
            d = 1/(A(q,iOrder(q)) + lambda(iOrder(q)));
            h = [h + d*B(q,iOrder(1:q-1)).^2,d];
        end
 % to update regularisation parameters
    gamma = ones(1,n) - lambda(iOrder(1:n)).*h;
    Gamma = sum(gamma);
  for i = 1:n
     if gamma(i) < 1e-20
         gamma(i) = 1e-20;
     end
 end
    lambda(iOrder(1:n)) = sse_y/(N-Gamma)*gamma./(a.^2)';
 for i = 1:n
     if lambda(iOrder(i)) > 1e20
         lambda(iOrder(i)) = 1e20;
     end
 end
    end 
    theta = a;
    lambda = lambda(iOrder(1:n));
return;

    

function [theta,A,iSels, Ad, iOrder,  sse_reduction, sse_y,Ay,B,C,lambda]=first_stage_selection(P,y,n,ReOrder,lambda_init)
    % lambda_init is a row vector with m elements
    
    [N,m] = size(P); %to obtain the number of data samples and number of regressors
	A = zeros(n,m); 
    lambda = lambda_init;
    sse_y = y'*y;
    B = zeros(n,m);
    C = zeros(m,n);
    sse_reduction = [];
	iOrder=1:m; 
	Ay=y'*P;					% 1*m vector the numerator value for calculation at the first stage
	Ad=sum(P.*P); % 1*m the diagonal elements of matrix A. also the denominator value for calculation at the first stage (need to add lambda)
	for k=1:n
		reod=iOrder(k:m);
		Reduces=Ay(reod).^2./(Ad(reod)+lambda(reod));	% 1*(n-k)
		[fMaxReduce,iMax]=max(Reduces);
        sse_reduction = [sse_reduction,fMaxReduce];
        sse_y = sse_y - fMaxReduce;
		cs=reod(iMax);
		reod(iMax) = [];                           %delete the selected term from candidate pool
		s=P(:,cs)'*P(:,reod);						% (m-k)*[N-1,N]   %%%phi_k^T*phi_i not including the selected kth term
		for q=1:k-1
			s=s-A(q,cs)/(A(q,iOrder(q)) + lambda(iOrder(q))) * A(q, reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,iOrder(q))=ajj
   		end
		A(k,[cs,reod])=[Ad(cs),s];               % update k-th row of matrix A
        iOrder(k:m)=[cs,reod];                     % sort-seleted index remaining index
		
        for q = 1:k-1
            B(k,iOrder(q)) = A(q,iOrder(k))/(A(q,iOrder(q)) + lambda(iOrder(q))); %update matrix B
            for l = q+1:k-1
                B(k,iOrder(q)) = B(k,iOrder(q)) - A(l,iOrder(k))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
            C(iOrder(q),k) = Ay(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q))))); %update matrix C
            for l = q+1:k-1
                C(iOrder(q),k) = C(iOrder(q),k) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
        end
                  
        %%%%%%%%%%%%%%up-compute kth A %%%%%%%%%%%%%%
			s=Ay(cs)/(A(k,cs)+lambda(cs))*A(k,reod);				% [0,m-k+1]
			Ay(reod)=Ay(reod)-s;					% [m-k,0]
			s=A(k,reod).^2/(A(k,cs)+lambda(cs));			% [0,m-k+1]
			Ad(reod) = Ad(reod) - s;				% [m-k,0]   
    end
    
%calculate the model parameters
    for q=1:n
        C(iOrder(q),n+1) = Ay(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q)))));
        for l = q+1:n
            C(iOrder(q),n+1) = C(iOrder(q),n+1) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
        end
    end
    theta = C(iOrder(1:n),k+1);
    iSels = ReOrder(iOrder(1:n));
	return;
    
    
    %this function is for debug only. However, it may be useful in some
    %situation. 
function [theta,A,iSels, Ad, iOrder, sse_reduction,sse_y,Ay,B,C,lambda]=selection_debug(P,y,n,ReOrder,selection_order,lambda_init)
    [N,m] = size(P); %to obtain the number of data samples and number of regressors
	A = zeros(n,m); 
    lambda = lambda_init;
    sse_y = y'*y;
    B = zeros(n,m);
    C = zeros(m,n);
    sse_reduction = [];
    index = 1:m;
    index(selection_order) = [];
	iOrder=1:m; 
	Ay=y'*P;					% 1*m vector the numerator value for calculation at the first stage
	Ad=sum(P.*P); % 1*m the diagonal elements of matrix A. also the denominator value for calculation at the first stage (need to add lambda)
	for k=1:n

		cs = selection_order(k);
		Reduces=Ay(cs).^2./(Ad(cs)+lambda(cs));	% 1*(n-k)
        sse_reduction = [sse_reduction,Reduces];
        sse_y = sse_y - Reduces;
        reod = [selection_order(k+1:n),index];
		s=P(:,cs)'*P(:,reod);						% (m-k)*[N-1,N]   %%%phi_k^T*phi_i not including the selected kth term
		for q=1:k-1
			s=s-A(q,cs)/(A(q,iOrder(q)) + lambda(iOrder(q))) * A(q, reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,iOrder(q))=ajj
   		end
		A(k,[cs,reod])=[Ad(cs),s];               % update k-th row of matrix A
        iOrder(k:m)=[cs,reod];                     % sort-seleted index remaining index
		
        for q = 1:k-1
            B(k,iOrder(q)) = A(q,iOrder(k))/(A(q,iOrder(q)) + lambda(iOrder(q))); %update matrix B
            for l = q+1:k-1
                B(k,iOrder(q)) = B(k,iOrder(q)) - A(l,iOrder(k))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
            C(iOrder(q),k) = Ay(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q))))); %update matrix C
            for l = q+1:k-1
                C(iOrder(q),k) = C(iOrder(q),k) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
        end
                  
        %%%%%%%%%%%%%%up-compute kth A %%%%%%%%%%%%%%
			s=Ay(cs)/(A(k,cs)+lambda(cs))*A(k,reod);				% [0,m-k+1]
			Ay(reod)=Ay(reod)-s;					% [m-k,0]
			s=A(k,reod).^2/(A(k,cs)+lambda(cs));			% [0,m-k+1]
			Ad(reod) = Ad(reod) - s;				% [m-k,0]   
    end
    
%calculate the model parameters
    for q=1:n
        C(iOrder(q),n+1) = Ay(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q)))));
        for l = q+1:n
            C(iOrder(q),n+1) = C(iOrder(q),n+1) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
        end
    end
    theta = C(iOrder(1:n),k+1);
    iSels = ReOrder(iOrder(1:n));
	return;