function loo_error = loo_error_calculation(P,P_im,r_im,e_im,A,b,k,u_s,u,y)
% currently, this function is used for PSO only
% This function is used to calculate the LOO of each RBF centre
% P is the previous selected regression matrix
% A and Ay is the temporary matrix
% k is the index of steps
% u_s are candidate RBF centres including position and width
% u and y are observed system inputs and outputs
%  load test_temple.mat
%  clear u_sigma;
[N,m] = size(u); % N is the total number of data samples, and m is the input dimension
s = length(u_s(1,:)); % each column in u_s represents a particle
u_dist = zeros(N,s); %the distance of each swarm with other data points


% % This is another way to produce the regression matrix
% for i_phi = 1:n
%      u_dist = u_dist + dist(u_s(i_phi,:)',u(:,i_phi)')'.^2./(ones(N,1)*u_s(n+i_phi,:));
% end
% Phi = exp(-0.5*sqrt(u_dist));

% Produce the regression matrix (maybe more efficient than above code)
u_mu = u_s(1:m,:)'; % the mean matrix used by Gaussian mixture distribution
u_sigma(1,:,:) = u_s(m+1:end,:); % the variance matrix used by Gaussian mixture distribution
obj = gmdistribution(u_mu,u_sigma); % used to compute Mahalanobis distance
d_mahal = mahal(obj,u); % compute the Mahalanobis distance
Phi = exp(-0.5 * sqrt(d_mahal)); % produce the regression matrix

% compute the loo error
if k == 1
    b(k:k+s-1)=Phi'*y;
    Ad=sum(Phi.*Phi); % a_{j,j} for j = 1, \cdots, s
    Phi_im = Phi; % p^{(0)}
    R_im = r_im * ones(1,s) - Phi_im.^2./(ones(N,1)*Ad);
    E_im = e_im * ones(1,s) - Phi_im.*(ones(N,1)*(b(k:k+s-1)'./Ad));
    loo_error = sum((E_im./R_im).^2)/N;
else
    % calculate the k-th column of matrix A

    Phi_im = Phi; % matrix
    for i = 1:k-1
        A(i,k:k+s-1) = P_im(:,i)'*Phi;
        Phi_im = Phi_im - P_im(:,i) * A(i,k:k+s-1) ./ A(i,i);
    end
    %Phi_im = Phi_im - P_im(:,k-1) * A(k-1,k:k+s-1) ./ A(k-1,k-1);
    A(k,k:k+s-1) = sum(Phi_im.*Phi);
    b(k:k+s-1) = Phi_im'*y;
    R_im = r_im * ones(1,s) - Phi_im.^2./(ones(N,1)*A(k, k:k+s-1));

    E_im = e_im * ones(1,s) - Phi_im.*(ones(N,1)*(b(k:k+s-1)'./A(k,k:k+s-1)));
    
    loo_error = sum((E_im./R_im).^2)/N;
end
        
return;