% P=randn(10,7);SelR=[1:2:size(P,2),6]';y=P(:,SelR)*SelR;
% [a,iSels,SSE,Context,SSERec]=mssAlgorithmFFB(P,y,4);
%input: P: candidate regression matrices,  y: output vector; n: desdired number of selections; 
% opt: 0-forward only, 1-forward+backward; 
% Output: a: regression coefficients (output weights), iSels: index of selected regressor;
% SSE: error of the model; Context: regression context; SSERec: records of SSEs for the selections;  
function [a,iSels,SSE,SSERec,Context]=mssTwoStage1(P,y,n,Opt,fMinAgl,Context)
	if nargin<5,fMinAgl=0;end
    if nargin<4,Opt=1;end
    if nargin<6 | isempty(Context)
	    Context.P=P;
	    Context.y=y;
	    Context.nSize=0;
	    Context.iOrder=1:size(P,2);
	    Context.A=zeros(1,size(P,2));
	    Context.Ay=y'*P;
	    Context.Ac=Context.Ay;
	    Context.D=sum(P.*P,1);
	    Context.SSE=y'*y;
	    Context.SSERec=[0,Context.SSE];
    end
	P=Context.P;
	[N,m]=size(P);
	y=Context.y;
	A=Context.A;
	Ac=Context.Ac;
	iOrder=Context.iOrder;
	Ay=Context.Ay;											% m*[N-1,N]
	D=Context.D;										% m*[N-1,N]
	SSE=Context.SSE;											% [N-1,N]
	SSERec=Context.SSERec;
	D0=D*(fMinAgl*pi/180);
	for k=Context.nSize+1:n
		rd=iOrder(k:m);
		Ayc=Ay(rd)./D(rd);								% (m-k+1)*[0,1]
		Reduces=Ayc.*Ay(rd);							% (m-k+1)*[0,1]
		[fMax,iMax]=max(Reduces.*(D(rd)>D0(rd)));
		rd([1,iMax])=rd([iMax,1]);
		cs=rd(1);
		rd=rd(2:end);
		pk=P(:,cs);
		A(k,[cs,rd])=[D(cs),pk'*P(:,rd)];				% (m-k)*[N-1,N];
		Ac(k,[cs,rd])=[D(cs),A(k,rd)/D(cs)];			% (m-k)*[0,1];
		P(:,rd)=P(:,rd)-pk*Ac(k,rd);					% (m-k)*[N,N];
		y=y-pk*Ayc(iMax);								% [N,N];
		Ay(rd)=y'*P(:,rd);								% (m-k)*[N-1,N]
		D(rd)=sum(P(:,rd).*P(:,rd),1);					% (m-k)*[N-1,N]
		SSE=SSE-fMax;
		SSERec=[SSERec;[k,SSE]];
		iOrder(k:m)=[cs,rd];
%		[a1,A1,SSE,Ay1,D1]=lstestFFR(P,y,iOrder,k);
%		[A-A1;Ay-Ay1;D-D1]% --- Check code
%		disp([sprintf('FS: %.6e[%3d',fResidual,iOrder(1)),sprintf(',%3d',iOrder(2:n)),']']);
	end
%	[a1,iSels1,SSE1,Context1,SSERec1]=mssTwoStage2(P0,y0,n,0);
%
	b=n-1;
	while b>0 & Opt
		for q=b:n-1
			ex1=iOrder(q);
			ex2=iOrder(q+1);
			qRaw=A(q,iOrder(q+1:m));
			rd=iOrder(q+2:m);
			r=A(q,ex2)/A(q,ex1);							% [0,1]
			A(q,[ex2,rd])=A(q+1,[ex2,rd])+r*qRaw;		% (m-q)*[1,1]
			A(q,ex1)=qRaw(1);
			Ac(q,ex2)=A(q,ex2);
			Ac(q,[ex1,rd])=A(q,[ex1,rd])/A(q,ex2);		% (m-q)*[0,1]
			s=Ac(q,ex1)*A(q,[ex1,rd]);					% [0,m-q]
			A(q+1,[ex1,rd])=[D(ex1),qRaw(2:end)]-s;		% [m-q,0]
			Ay(ex2)=Ay(ex2)+r*Ay(ex1);					% [1,1]
			Ay(ex1)=Ay(ex1)-Ac(q,ex1)*Ay(ex2);			% [1,1]
			D([ex2,ex1])=[A(q,ex2),A(q+1,ex1)];
			P(:,ex2)=P(:,ex2)+r*P(:,ex1);				% [N,N];
			P(:,ex1)=P(:,ex1)-Ac(q,ex1)*P(:,ex2);		% [N,N];
			A(q+1,ex2)=0;
			Ac(q+1,ex2)=0;
			iOrder([q,q+1])=iOrder([q+1,q]);
%			[a1,A1,SSE,Ay1,D1]=lstestFFR(P,y,iOrder,k);
%			[A-A1;Ay-Ay1;D-D1]% --- Check code
		end
		cs=iOrder(n);
		rd=iOrder(n+1:m);
		Ac(n,[cs,rd])=[A(n,cs),A(n,rd)/A(n,cs)];		% [0,m-n]
%		[a1,A1,SSE,Ay1,D1]=lstestFFR(P,y,iOrder,n);
%		[A-A1;Ay-Ay1;D-D1]% --- Check code
		Dq=D(rd)+Ac(n,rd).*A(n,rd);						% (m-n)*[1,1]
		Ayq=Ay(rd)+Ay(cs)*Ac(n,rd);						% (m-n)*[1,1]
%		[a2,A2,SSE,Ay2,D2]=lstestFFR(P,y,iOrder,n,0);
%		[[D(iOrder(1:n)),Dq];[Ay(iOrder(1:n)),Ayq]]-[D2(iOrder);Ay2(iOrder)]% --- Check code
		ry=[Ay(cs),Ayq]./[D(cs),Dq];						% (m-n+1)*[0,1]
		Reduces=ry.*[Ay(cs),Ayq];						% (m-n+1)*[0,1]
		[fMax,iMax]=max(Reduces.*[1,Dq>D0(rd)]);
		if iMax~=1
			Ay(rd)=Ayq;
			D(rd)=Dq;
			P(:,rd)=P(:,rd)+P(:,cs)*Ac(n,rd);			% (m-n)*[N,N]
			y=y+ry(1)*P(:,cs);							% [N,N]
			iOrder([n,n+iMax-1])=iOrder([n+iMax-1,n]);
			cs0=cs;
			cs=iOrder(n);
			rd=[iOrder(n+1:m)];
			A(n,cs0)=A(n,cs);
			A(n,cs)=D(cs);
			rd(iMax-1)=[];
			A(n,rd)=P(:,cs)'*P(:,rd);					% (m-n-1)*[N-1,N]
			rd=[iOrder(n+1:m)];
			Ac(n,[cs,rd])=[A(n,cs),A(n,rd)/A(n,cs)];	% [0,m-n]
			P(:,rd)=P(:,rd)-P(:,cs)*Ac(n,rd);			% (m-n)*[N,N]
			y=y-ry(iMax)*P(:,cs);						% [N,N]
			Ay(rd)=Ay(rd)-Ay(cs)*Ac(n,rd);				% (m-n)*[1,1]
			D(rd)=D(rd)-Ac(n,rd).*A(n,rd);				% (m-n)*[1,1]
			SSE=SSE-(fMax-Reduces(1));					% [2,0]
			SSERec=[SSERec;[n,SSE]];
%			[a3,A3,SSE,Ay3,D3]=lstestFFR(P,y,iOrder,k);
%			[A-A3;Ay-Ay3;D-D3]% --- Check code
%			disp([sprintf('BS: %.6e[%3d',fResidual,iOrder(1)),sprintf(',%3d',iOrder(2:k)),']']);
			%disp([sprintf('%.4e: ',SSE) sprintf('%d ',iOrder(1:n))]);
			b=n-1;
		else
			b=b-1;
		end
	end
%
    Context.nSize=n;
    Context.iOrder=iOrder;
    Context.A=A;
    Context.Ay=Ay;
    Context.Ac=Ac;
    Context.D=D;
    Context.P=P;
    Context.y=y;
    Context.SSE=SSE;
    Context.SSERec=SSERec;
    iSels=iOrder(1:n);
	A=[Ac(:,iSels),Ay(iSels)'];
	a=A(:,end)./diag(A(:,1:end-1));								% [0,n]
	for k=n-1:-1:1
		a(k)=a(k)-A(k,k+1:n)*a(k+1:n);					% [n-k,n-k];
	end
%	[a2,A2,P2]=tempCompFB(P0(:,1:end-1),P0(:,end),rd);
	Context.a=a;
	return;

function [a,A,fResidual,Ay,Norm2]=tempCompFB(P,y,ReOrder,n,bLast)
	if nargin<5,bLast=1;end
	if isempty(bLast),bLast=0;end
	[N,m]=size(P);
	A=zeros(n,m);
	a=zeros(n,1);
	fResidual=y'*y;
	Ay=y'*P;										% m*[N-1,N]
	Norm2=sum(P.*P);								% m*[N-1,N]
	for k=1:n
		cs=ReOrder(k);
		reod=ReOrder(k+1:m);
		Reductions(k)=Ay(cs).*Ay(cs)./Norm2(cs);
		s=P(:,cs)'*P(:,reod);
		if k>1
			bk=A(1:k-1,cs)./Norm2(ReOrder(1:k-1))';
			bk=bk(:,ones(m-k,1));
			s=s-sum(bk.*A(1:k-1,reod));
		end
		A(k,[cs,reod])=[Norm2(cs),s];
		if k<n | bLast
			s=Ay(cs)/A(k,cs)*A(k,reod);				% [0,m-k+1]
			Ay(reod)=Ay(reod)-s;					% [m-k,0]
			s=A(k,reod).*A(k,reod)/A(k,cs);			% [0,m-k+1]
			Norm2(reod)=Norm2(reod)-s;				% [m-k,0]
		end
		fResidual=fResidual-Reductions(k);
	end
	for k=n:-1:1
		cs=ReOrder(k);
		reod=ReOrder(k+1:n);
		if k<n
			a(k)=Ay(cs)-A(k,reod)*a([k+1:n]);		% [n-k,n-k]
		else
			a(k)=Ay(cs);							% [n-k,n-k]
		end
		a(k)=a(k)/A(k,cs);							% [0,1]
	end
%	iSels=iOrder(1:n);
%	A=[A(:,iOrder(1:n)),Ay(iOrder(1:n))'];
	return;
