function Reduces = net_contribution(P,A,Ay,k,u_s,u,y)
% currently, this function is used for PSO only
% This function is used to calculate the contribution of a RBF centre
% P is the previous selected regression matrix
% A and Ay is the temporary matrix
% k is the index of steps
% u_s are candidate RBF centres including position and width
% u and y are observed system inputs and outputs
% load test_temple.mat
[N,n] = size(u); % N is the total number of data samples, and n (use p or m may be better) is the input dimension
s = length(u_s(1,:)); % each column in u_s represents a particle
u_dist = zeros(N,s); %the distance of each swarm with other data points


% % This is another way to produce the regression matrix
% for i_phi = 1:n
%      u_dist = u_dist + dist(u_s(i_phi,:)',u(:,i_phi)')'.^2./(ones(N,1)*u_s(n+i_phi,:));
% end
% Phi = exp(-0.5*sqrt(u_dist));

% Produce the regression matrix (maybe more efficient than above code)
u_mu = u_s(1:n,:)'; % the mean matrix used by Gaussian mixture distribution
u_sigma(1,:,:) = u_s(n+1:end,:); % the variance matrix used by Gaussian mixture distribution
obj = gmdistribution(u_mu,u_sigma); % used to compute Mahalanobis distance
d_mahal = mahal(obj,u); % compute the Mahalanobis distance
Phi = exp(-0.5 * sqrt(d_mahal)); % produce the regression matrix

% compute the net contribution
if k == 1
    Ay=y'*Phi;
    Norm2=sum(Phi.*Phi);
    Reduces=Ay.*Ay./Norm2;
else
    % calculate the k-th column of matrix A
    for i = 1:k-1
        A(i,k:k+s-1) = P(:,i)'*Phi;
        for j = 1:i-1
            A(i,k:k+s-1) = A(i,k:k+s-1) - A(j,i)/A(j,j)*A(j,k:k+s-1);
        end
    end
    A(k,k:k+s-1) = sum(Phi.*Phi);
    for j = 1:k-1
        A(k,k:k+s-1) =  A(k,k:k+s-1) - A(j,k:k+s-1)/A(j,j).*A(j,k:k+s-1);
    end
    
    %calculate the k-th elements of matrix Ay
    Ay(k:k+s-1,:) = Phi'*y;
    for j = 1:k-1
        Ay(k:k+s-1) = Ay(k:k+s-1) - Ay(j)/A(j,j)*A(j,k:k+s-1)';
    end
    Reduces=Ay(k:k+s-1)'.^2./A(k,k:k+s-1);
end
        
return;